#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <cstdio>

inline long long isqrt(long long a) {
	if (a < 4) return 1; long long r = 2 * isqrt((a - a % 4) / 4), t = r + 1; if (t * t <= a) r = t; return r;
}

enum t_side { INTERNAL, EXTERNAL };

inline long long index(long long min, long long len, long long mid, int dir, long long rad, t_side side) {
	//Приводим расстояние к виду: t + e, где t -- целое, 0 <= e < 1;
	long long tmp = (rad)? isqrt(rad): (0); int eps = (tmp * tmp == rad)? (0): (dir);
	//Определяем индекс ячейки, содержащей соответствующую границу:
	mid = mid + dir * tmp - min; if (mid < 0) { return - 1; }
	long long ind = mid / len;
	if (mid % len == 0) {	//Если лежит строго на границе двух ячеек;
		if (!eps && (side != EXTERNAL)) ind += dir;
		ind -= (dir > 0);	//Округляем в меньшую сторону;
		ind += eps;
	}
	return (ind);
}

#define REAL_TO_LONG (100000)

inline void fscan_real_to_long(FILE *fid, long long &val) {
	static long long p1, p2; static long ll; static char bf[6], ch; fscanf(fid, " ");
	ch = fgetc(fid); ungetc(ch, fid);
	if (fscanf(fid, "%lli.%5[0-9]", &p1, bf) < 2) bf[0] = '\0';
	ll = strlen(bf);
	memset(bf + ll, '0', 5 - ll);
	p2 = atol(bf);
	if (p1 < 0) { val = p1 * REAL_TO_LONG - p2; return; }
	if (p1 > 0) { val = p1 * REAL_TO_LONG + p2; return; }
	val = (ch == '-')? (- p2): (p2);
}

int main() {
	//...
	long long minx, miny, lenx, leny, numx, numy, midx, midy, rad1, rad2, radx, rady;
	FILE *finp = fopen("input.txt", "rt");
	fscan_real_to_long(finp, minx); fscan_real_to_long(finp, miny);
	fscan_real_to_long(finp, lenx); fscan_real_to_long(finp, leny);
	fscanf(finp, "%llu", &numx);
	fscanf(finp, "%llu", &numy);
	fscan_real_to_long(finp, midx); fscan_real_to_long(finp, midy);
	fscan_real_to_long(finp, rad1);
	fscan_real_to_long(finp, rad2);
	fclose(finp);
	//...
	long long tx1 = index(minx, lenx, midx, -1, rad2 * rad2, EXTERNAL);
	long long tx2 = index(minx, lenx, midx, -1, rad1 * rad1, INTERNAL);
	long long tx3 = index(minx, lenx, midx, +1, rad1 * rad1, INTERNAL);
	long long tx4 = index(minx, lenx, midx, +1, rad2 * rad2, EXTERNAL);
	long long ty1 = index(miny, leny, midy, -1, rad2 * rad2, EXTERNAL);
	long long ty2 = index(miny, leny, midy, +1, rad2 * rad2, EXTERNAL);
	long long tx0 = index(minx, lenx, midx, -1, 0, INTERNAL);
	long long ty0 = index(miny, leny, midy, -1, 0, INTERNAL);
	//...
	long long cx1, cx2, cx3, cx4, ix1, ix2, ix3, ix4; long long yy1, yy2; bool fl1, fl2;
	long long ans = 0;
	//...
	long long iy1 = ty1; ty1 = miny + ty1 * leny - midy; ty2 = miny + ty2 * leny - midy;
	long long lx1, lx2, lx3, lx4;
	bool tt1 = false, tt2 = false;
	bool is1 = false, is2 = false;
	ix1 = tx0; ix2 = tx0;
	ix3 = tx0; ix4 = tx0;
	for (yy1 = ty1, yy2 = ty1 + leny; yy1 <= ty2; yy1 = yy2, yy2 += leny, ++ iy1) {
		radx = (rad2 - yy2) * (rad2 + yy2);
		if (fl2 = (radx >= 0)) {
			ix1 = cx1 = index(minx, lenx, midx, -1, radx, EXTERNAL);
			ix4 = cx4 = index(minx, lenx, midx, +1, radx, EXTERNAL);
		}
		radx = (rad1 - yy2) * (rad1 + yy2);
		if (fl1 = (radx >= 0)) {
			ix2 = cx2 = index(minx, lenx, midx, -1, radx, INTERNAL);
			ix3 = cx3 = index(minx, lenx, midx, +1, radx, INTERNAL);
		}
		is2 = tt2 && fl2; is1 = tt1 && fl1;
		if (tt2) {
			ix1 = std::min(cx1, lx1); ix4 = std::max(cx4, lx4);
		}
		if (tt1) {
			ix2 = std::max(cx2, lx2); ix3 = std::min(cx3, lx3);
		}
		if (yy1 * yy2 < 0) {
			ix1 = tx1; ix4 = tx4;
		}
		lx1 = cx1; lx2 = cx2;
		lx3 = cx3; lx4 = cx4;
		tt2 = fl2; tt1 = fl1;
		if ((iy1 < 0) || (iy1 >= numy) || (ix4 < 0) || (ix1 >= numx)) {
			continue;
		}
		ix1 = std::max(ix1, 0LL); ix2 = std::min(ix2, numx - 1);
		ix3 = std::max(ix3, 1LL + ix2);
		ix4 = std::min(ix4, numx - 1);
		if (is1) {
			if (ix2 >= ix1) ans += (ix2 - ix1 + 1);
			if (ix4 >= ix3) ans += (ix4 - ix3 + 1);
		}
		else {
			if (ix4 >= ix1) ans += (ix4 - ix1 + 1);
		}
	}
	//...
	FILE *fout = fopen("output.txt", "wt");
	fprintf(fout, "%lli", ans);
	fclose(fout);
	//...
	return 0;
}
